<script lang="ts">
  import {
    Button,
    Dropdown,
    DropdownItem,
    DropdownMenu,
    DropdownToggle,
    FormGroup,
    Input,
    InputGroup,
    InputGroupText,
    Modal, Tooltip
  } from "@sveltestrap/sveltestrap";
  import { eventId as eventIdStore } from "@stores";
  import { createKanbanTask, taskOptions } from "@models/Kanban";
  import EditMarkdown from "@components/Markdown/EditMarkdown.svelte";
  import { getNotificationsContext } from "svelte-notifications";
  import oidc from "@auth/keycloak";

  const { addNotification } = getNotificationsContext();

  export let open = false;
  export let selectedStatus: string = taskOptions[0].status;
  export let teamId: string;
  export let eventId: string = $eventIdStore;

  let assignSelf = true;
  let title = "";
  let description = "";

  function saveTask(stayOpen = false) {
    if(!(title && description)) {
      addNotification({
        text: "Please include a Title and Description",
        type: "error",
        position: "bottom-right",
        removeAfter: 4000
      });
      return;
    }
    createKanbanTask({
      assignee_id: assignSelf ? oidc.userId : undefined,
      created_by: oidc.userId!,
      title,
      description,
      status: selectedStatus,
      team_id: teamId,
      event_id: eventId
    });
    title = "";
    description = "";
    open = stayOpen;
    addNotification({
      text: "Task created successfully",
      type: "info",
      position: "bottom-right",
      removeAfter: 4000
    });
  }

  $: console.log(selectedStatus);

  export function toggle() {
    open = !open;
  }
</script>

<Modal isOpen={open} {toggle} size="lg">
  <div class="modal-content">
    <div class="modal-header">Create New Task</div>
    <div class="modal-body">
      <FormGroup>
        <InputGroup class="mb-3">
          <InputGroupText>Title</InputGroupText>
          <Input bind:value={title} placeholder="Hack all the things!" />
        </InputGroup>
        <InputGroup class="mb-3 text-white">
          <h3>Description</h3>
          {#key description}
            <EditMarkdown
              text={description}
              minHeight="120px"
              multiline
              placeholder="I'm going to perform the task..."
              alwaysEditing
              on:save={(event) => {
                description = event.detail;
              }}
            />
          {/key}
        </InputGroup>

        <div class="d-flex">
          <InputGroup  style="flex: 2">
            <InputGroupText>Status:</InputGroupText>
            <Input class="me-4" label="Status" type="select" bind:value={selectedStatus}>
              {#each taskOptions as op}
                <option value={op.status} class="clickable">
                  {op.status}
                </option>
              {/each}
            </Input>
          </InputGroup>
          <Input type="switch" bind:checked={assignSelf} class="clickable" label="Assign Self" />
        </div>
      </FormGroup>
    </div>

    <div class="modal-footer">
      <Button id="create-continue-btn" on:click={() => saveTask(true)} color="primary">
        Create and Continue
      </Button>
      <Tooltip target="create-continue-btn">
        Create task and leave this modal open to create another task.
      </Tooltip>
      <Button color="success" on:click={() => saveTask()}>Create
      </Button>
    </div>
  </div>
</Modal>
